--File : ASPToVB.ex
--Author : Tone koda  e-mail: tone.skoda@siol.net
--Created : 19. november 2000
--Purpose : executable file for ASPToVB module.

without warning
with trace

include ASPToVB.e

global constant
    Banner  = "+==========================================+\n" &
              "| ASPToVB version 1.0                      |\n" &
              "| Built: November, 2000                    |\n" &
              "|==========================================|\n" &
              "| AspToVB (c) Tone Skoda                   |\n" &    
              "| Translate ASP file to Visual Basic DLL   |\n" &
              "| source file or to an ASP file which will |\n" &
			  "| have no HTML code in it.                 |\n" &
              "+==========================================+\n\n"
              



--command prompt format:
--1.source file, required
--2.destination file, required
--3.tranlate to asp page(0) or to vb source file(1)
--		optional, 1 is default
--4.if 0 then tabs are from HTML, if 1 then tabs are from
--	VB code, if 2 then tabs are from both, optional, 2 is default
--example : ASPToVB.ex test.asp test.cls 0 2
procedure main()
	sequence srcFile,dstFile
	sequence cmd
	sequence tmp
	integer toVB	
	integer whoseTabs

    -- display banner
	text_color(BLUE)
    puts( 1, Banner )
	text_color(WHITE)
		
	puts(1,"\nWarning: If destination file already exist it will be overwritten!\n\n")

	cmd = command_line()

	if length( cmd ) >= 3 then
		srcFile=cmd[3]
		puts(1,"\nSource file is '" & srcFile & "'.\n")
	else
		-- prompt the user
		srcFile=prompt_string("Asp file to translate:")
	end if


	if length( cmd ) >= 4 then
		dstFile=cmd[4]
		puts(1,"\nDestination file is '" & dstFile & "'.\n")
	else
		-- prompt the user
		dstFile=prompt_string("Destination file:")
	end if


	if length( cmd ) >= 5 then
		tmp=cmd[5]
		toVB=atoi(tmp)
		puts(1,"\nTo VB is '" & tmp & "'.\n")
	else
		--not required
		toVB=1
		puts(1,"\nTo VB is '" & itoa(toVB) & "'.(default)\n")
	end if

	if length( cmd ) >= 6 then
		tmp=cmd[6]
		whoseTabs=atoi(tmp)
		puts(1,"\nwhoseTabs is '" & tmp & "'.\n")
	else
		--not required
		whoseTabs=2
		puts(1,"\nwhoseTabs is '" & itoa(whoseTabs) & "'.(default)\n")
	end if

	ASPToVB_Do(srcFile,dstFile,whoseTabs,toVB)

	puts(1,"\nDone. See file '" & dstFile & "' for results.")
end procedure


main()