--Author: Tone koda  e-mail: tone.skoda@siol.net
--miscalenous routines, non platform related

include Skoda\TSTypes.e
include wildcard.e
include sort.e



---------------------------------------------------------------------------
function mySort( object o1, object o2 )
    if atom( o1 ) then
        return compare( o1, o2 )
    elsif sequence(o1) then
        return compare( upper(o1), upper(o2) )
    end if
end function

-------------------------------------------------------------------------------
--sort non case sensitive
global function sort_no_case_sens( sequence s )
    return custom_sort( routine_id("mySort"), s )
end function

constant month={
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December"
}

--returns string with date
--7. July 2000
---------------------------------------------------------------------------
global function GetDate()
	sequence s
	s = date() 

	return sprintf("%d%s%s%s%d",
		{
		s[3], --day
		". ",
		month[s[2]], --month
		" ",
		1900+s[1] --year
		})
end function