<%
'File		: FileExplorer.asp
'Author		: Tone koda  e-mail: tone.skoda@siol.net
'Created	: 11. november 2000
'Purpose	:	Explore directories on server.
'				It's too slow to browse big directories
'				so it's only useful for small directories.
'
'Needed files:	TreeView.js
'				scroll2.js
'				dynlayer.js
'				mouseevents.js
'
'---------------------------------------------------------------------------
'EXPLORED FUNCTIONS:
'TSFE_Initialize()	- have to call this function in <head> of your html site
'TSFE_Explore()		- main function, define which folder to browse ...
'EXPLORED FUNCTIONS.
'---------------------------------------------------------------------------


Option Explicit
'Response.Buffer = True

''''''''''''customize these:
dim g_file_item_hei		'file item height
g_file_item_hei=20

dim g_fileImage		
'g_fileImage="images/list1.gif"
g_fileImage="images/f.gif"

dim g_imgImage		'image displayed with image files
g_imgImage="images/list2.gif"

dim g_zipImage
g_zipImage="images/zip.jpg"

dim g_interImage
g_interImage="images/list.gif"

dim g_aspImage
g_aspImage="images/script.gif"

dim g_infoDivHei
g_infoDivHei=20

dim g_helpDivHei
g_helpDivHei=20

dim TSFEId		'id of ts file explorer
TSFEId="TSFE"

''''''''''''customize these.

Dim ok

dim g_fs
Set g_fs = CreateObject("Scripting.FileSystemObject")

Dim g_treeitems_count	'counts how many tree items
						'inserted till that moment

'subm_ = values got out of submited forms
dim g_subm_req			'if true then user is requesting
						'file list of directory else not
dim g_subm_id			'tells which folder is selected
						'to show its files, index where
						'at a row
						'(0=root, 1=first after root, etc...)
dim g_arrSubm_expf		'array with items that tell which
						'folders are expanded
						'format got  with request is like this:
						'example: "1,0,1,..."
						'if 1 folder is expanded else not
dim g_subm_selItem		'selected item id


g_treeitems_count=0
g_subm_req=0


'***********************************************************************************
' GetFileExtension()
' Purpose:  Returns the extension of a filename
' Inputs:   strFileName     -- string containing the filename
'           varContent      -- variant containing the filedata
' Outputs:  a string containing the fileextension
'***********************************************************************************

Function GetFileExtension(strFileName)

    GetFileExtension = Mid(strFileName, InStrRev(strFileName, ".") + 1)
    
End Function



function IsZipFile(ext)
	dim lc
	lc=lcase(ext)
	if lc="zip" or lc="rar" or lc="arj" then
		IsZipFile=1
	else
		IsZipFile=0
	end if
end function

'is internet file (a site)
function IsInterFile(ext)
	dim lc
	lc=lcase(ext)
	if lc="htm" or lc="html" then
		IsInterFile=1
	else
		IsInterFile=0
	end if
end function

'is asp file
function IsAspFile(ext)
	dim lc
	lc=lcase(ext)
	if lc="asp" or lc="inc" or lc="asa" then
		IsAspFile=1
	else
		IsAspFile=0
	end if
end function


function IsPicFile(ext)
	dim lc
	lc=lcase(ext)
	if lc="jpg" or lc="gif" or lc="bmp" then
		IsPicFile=1
	else
		IsPicFile=0
	end if
end function



' *******************************************************
' Recursively perform the actual quicksort algorithm.
' It does not know the difference between upper and lower case letters (A=a)
' *******************************************************
Sub Quicksort_DontMatchCase (List(), min , max )
Dim med_value 
Dim hi 
Dim lo 
Dim i 
dim med_value_low

    ' If the list has no more than 1 element, it's sorted.
    If min >= max Then Exit Sub

    ' Pick a dividing item.
    i = Int((max - min + 1) * Rnd + min)
    med_value = List(i)
	med_value_low=LCase(med_value)

    ' Swap it to the front so we can find it easily.
    List(i) = List(min)

    ' Move the items smaller than this into the left
    ' half of the list. Move the others into the right.
    lo = min
    hi = max
    Do
        ' Look down from hi for a value < med_value.
        Do While LCase(List(hi)) >= med_value_low
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            List(lo) = med_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        List(lo) = List(hi)
        
        ' Look up from lo for a value >= med_value.
        lo = lo + 1
        Do While List(lo) < med_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            List(hi) = med_value
            Exit Do
        End If
        
        ' Swap the lo and hi values.
        List(hi) = List(lo)
    Loop
    
    ' Sort the two sublists
    Quicksort_DontMatchCase  List, min, lo - 1
    Quicksort_DontMatchCase  List, lo + 1, max
End Sub



'you have to put this sub in head of your html site
sub TSFE_Initialize()
%>
	<script language="JavaScript" src="dynlayer.js"></script>
	<script language="JavaScript" src="mouseevents.js"></script>
	<script language="JavaScript" src="scroll2.js"></script>

	<script language="JavaScript" src="TreeView.js"></script>

	<script language="javascript">
	
	initTreeView()

	//for netscape - set file list after load
	function onLoadIntervalF()
	{
		if(g_strFileList.length>0)
		{
			clearInterval(onLoadInterval)
			var lyr=g_fileListLayer.document
			lyr.open()
			lyr.write(g_strFileList)
			lyr.close

			lyrWrt("SelectedInfo",g_strSelFoldPath)

			filesScroll.activate(1000,g_iFileNamesCount*25)
		}
	}


	function onItemIMGClickProc(item)
	{
		if(bw.ie)
		{		
			eval("SelectedInfo").innerHTML=g_arrFullFoldNames[item.id]
		}
		else if(bw.ns)
		{
			lyrWrt("SelectedInfo",g_arrFullFoldNames[item.id])
		}
	}

	
	//when file item text is clicked this function launches
	function onFileClick(iFileIndex)
	{
		if(bw.ie)
		{
			eval("SelectedInfo").innerHTML=g_selFoldPath+'\\'+g_arrFileNames[iFileIndex]

			obj=eval("TSFEFileItem"+iFileIndex).style
			obj.background='lightyellow'

			if(g_iSelFileItem!=-1)
			{
				obj=eval("TSFEFileItem"+g_iSelFileItem).style
				obj.background='white'
			}			

		}//IE
		else if(bw.ns)
		{
			lyrWrt("SelectedInfo",g_selFoldPath+'\\'+g_arrFileNames[iFileIndex])
			
			obj=g_fileListLayer.layers["TSFEFileItem"+iFileIndex]
			obj.bgColor="lightyellow"

			if(g_iSelFileItem!=-1)
			{
				obj=g_fileListLayer.layers["TSFEFileItem"+g_iSelFileItem]
				obj.bgColor="white"
			}
		}//NS
		
		g_iSelFileItem=iFileIndex	
	}

	//returns "1,0,0,1,1,0..."
	//comma separated values with info if items expanded
	function getExpInfo(allItmes)
	{
		var ret
		
		ret=""

		for(i=0;i<allItmes.length;i++)
		{
			ret+=allItmes[i].exp + ","
		}

		return ret
	}

	//INDEPENDENT
	//NS and IE
	//example: lyrWrt("myId","my text") 
	function lyrWrt(id,text) 
	{
		if (document.layers)
		{
			//alertObjProp(document.layers[id])
			var lyr = document.layers[id].document
			lyr.open()
			lyr.write(text)
			lyr.close()
		}
		else
		{
			document.all[id].innerHTML = text
		}
	}
	
	//when folder text is clicked
	function onItemClickProc(item)
	{
		var id=item.id
		
		var df=document.TSFEform1		
		df.TSFEidOfClickedItem.value=id
		df.TSFEexpFolders.value=getExpInfo(tree.allItems)
		df.TSFEselItem.value=tree.selItem		

		//download file list for the folder user clicked
		document.TSFEform1.submit()		
	}

	</script>
	
	<style type="text/css">
	.fileItem{position:absolute;color:darkblue;}
	.mainTree{position:absolute;left:100;}
	.fileLinkStyle{text-decoration: none;color:green;font-family: "verdana"; fontSize:20;}
	.NSInfoLayer{color:green;fontSize:10;}
	  
	</style>
<%	
end sub


sub InsertAllSubFolders(parentSub)
	dim foldCountp
	%>
	window.status="Getting all sub folders from server ........"
	<%
	foldCountp=NumSubFolders(parentSub)
	ok=InsertSubsToOne(parentSub,0,foldCountp)
	%>	
	window.status="Getting all sub folders from server ........ Done"

<%
end sub

'search in arrays, returns index where in 'arr' is 'what' element
'if not found returns -1
'INDEPENDENT
function find(arr,what)
	dim item,count
	count=0
	for each item in arr
		if(what=item)then
			find=count
			exit function
		end if
		count=count+1
	next
	find=-1
end function

'returns number of subfolders
'(just folders directly under) 'folderspec' has
function NumSubFolders(folderspec)
    Dim fs, f, f1, fc,count	
    Set f = g_fs.GetFolder(folderspec)
    Set fc = f.SubFolders
	count=0
    For Each f1 in fc
        count=count+1
    Next
	NumSubFolders=count
End function

'returns lenght of array
function arrLen(arr)
	dim len
	for each i in arr
		len=len+1
	next
	arrLen=len
end function


'in right layer window lists files that are under
'selected folder 'strFoldPath'
sub SetFileList(strFoldPath)
	dim f,fc,f1
	dim arrFNames()		'array of file names
	dim fcount			'files count
	dim fname
	dim ext
	dim isPict		'is picutre file
	dim j
	dim strFImg		'file image name
	dim vbtmp
	dim counter

	fcount=0	

	%>
	g_selFoldPath="<%=strFoldPath%>"
	<%

	Set f = g_fs.GetFolder(strFoldPath)
    Set fc = f.Files

	'write file names into array
	for each f1 in fc
		redim preserve arrFNames(fcount)
		arrFNames(fcount)=f1.name
		fcount=fcount+1
	next

	'sort file names (from a-z)
	Quicksort_DontMatchCase arrFNames,0,fcount-1
	%>
	
	//count of files listed
	g_iFileNamesCount=0
	
	//in here saved main file list body
	jstmp1=""

	if(bw.ie)
	{
		def_layer='\n<div id=TSFEFileItem'
		def_layer_end='\n</div>'
	}
	else if(bw.ns)
	{
		def_layer='\n<layer name=TSFEFileItem'
		def_layer_end='\n</layer><br>'
	}

	<%
	counter=0 'has same value as JS var. g_iFileNamesCount, counts files listed

	'build html text from array of file names
	for each fname in arrFNames
		
		'get file extension (needed for file icons)
		ext=GetFileExtension(fname)

		'FILE ICON:
		if IsPicFile(ext) then
			strFImg=g_imgImage
		elseif IsZipFile(ext) then
			strFImg=g_zipImage
		elseif IsInterFile(ext) then
			strFImg=g_interImage
		elseif 	IsAspFile(ext) then
			strFImg=g_aspImage
		else
			strFImg=g_fileImage 
		end if
		'FILE ICON.
		%>
		jstmp1+=def_layer+'<%=counter%>'
		jstmp1+=">"

		jstmp1+=" <a href=javascript:onFileClick("
		jstmp1+=<%=counter%> + ") class=fileLinkStyle>"

		jstmp1+="<img border=0 align=center hspace=10 src=" + '<%=strFImg%>' + ">"		

		jstmp1+="<%=fname%>" + "<br>"
		jstmp1+="</a>"
		jstmp1+=def_layer_end
		<%counter=counter+1%>
		g_arrFileNames[g_iFileNamesCount]="<%=fname %>"
		g_iFileNamesCount++
		<%
	next
	%>
	
	if(bw.ie)
	{
		jstmp='<div NOWRAP class="fileItem"'
		jstmp+='>'
		jstmp+=jstmp1
		jstmp+='\n</div>'
	}
	else if(bw.ns)
	{
		jstmp='\n<table><td nowrap>\n'+jstmp1+'</td></table>'
	}
	
	
	if(bw.ie)
	{
		eval("FileList").innerHTML=jstmp
		eval("SelectedInfo").innerHTML="<%=strFoldPath%>"
	}
	else if(bw.ns)
	{
		//we will have to do it later in netscape
		//so for now just save the built html text
		g_strFileList=jstmp
		g_strSelFoldPath="<%=strFoldPath%>"

		//this does not work in netscape, don't know why
		//lyrWrt("SelectedInfo",'<%=strFoldPath%>')
		//lyrWrt("FileList",jstmp)
	}
	<%
end sub


'inserts subfolders for one folder and calls itself if neccessary
'this is main function for getting all subfolders under one folder
'arg. parentSub= full path to parent folder
'arg. foldCount: number of folders under parentSub folder
function InsertSubsToOne(parentSub,x,foldCount)
	dim fs,f,fc,f1,count,prevItemName
	dim j
	dim name,nextFullName
	dim nextf,nextfc
	dim foldArr()
	dim foldCountp
	dim foldName
	dim exp
	
	Set f = g_fs.GetFolder(parentSub)
    Set fc = f.SubFolders
	
	if(x>0) then
		prevItemName="item" & cstr(x-1)
	else
		prevItemName="root"
	end if

	'write subfolder names into array (1st level folders only)
	redim foldArr(foldCount-1)
	count=0
	for each f1 in fc
		foldArr(count)=f1.name
		count=count+1
	next

	'sort 1st level folders (a-z)
	Quicksort_DontMatchCase foldArr,0,foldCount-1

	'in this loop write html to document
	'and get all subfolders by calling self function
	for each foldName in foldArr
		
		nextFullName=parentSub & "\\" & foldName
		foldCountp=NumSubFolders(nextFullName)
		
		'this is the folder user clicked?
		if g_treeitems_count=g_subm_id then
			SetFileList(nextFullName)
		end if
		
		'redim preserve g_arrFullFoldNames(g_arrFullFoldNames_Count)
		'g_arrFullFoldNames(g_arrFullFoldNames_Count)=nextFullName
		'g_arrFullFoldNames_Count=g_arrFullFoldNames_Count+1
		%>
		g_arrFullFoldNames[g_arrFullFoldNames_Count]="<%=nextFullName%>"
		g_arrFullFoldNames_Count++
		<%
		
		if g_subm_req then
			exp=g_arrSubm_expf(g_treeitems_count)
		else
			exp=0
		end if
		
		g_treeitems_count=g_treeitems_count+1
		
		if(foldCountp>0)then%>
			item<%=x%>=tree.insertItem(<%=prevItemName%>,"<%=foldName%>",fullFoldImage,selImage,<%=exp%>,"<%=nextFullName%>")
			<%Call InsertSubsToOne(nextFullName,x+1,foldCountp)%>
		<%else%>
			item<%=x%>=tree.insertItem(<%=prevItemName%>,"<%=foldName%>",image,selImage,<%=exp%>,"<%=nextFullName%>")
		<%
		end if
	next
    
end function


'from "C:\\igre\abra" returns "C:\\igre\\abra"
function FormatPathSlashes(path)
	dim ret
	ret=replace(path,"\","\\")
	ret=replace(ret,"\\\\","\\")
	FormatPathSlashes=ret
end function

'---------------------------------------------------------------------------
'this is main function of this file
'left,top,width,height: in what (little frame window with scrolls)
	'will treeview be displayed
'arg. aspFileName : name of asp file which calls this function
'	(needed for form.submit)
'	you can get it like this:
'	Set fs = CreateObject("Scripting.FileSystemObject")
'	aspFileName=fs.GetFileName(Request.ServerVariables("PATH_INFO"))
'---------------------------------------------------------------------------
sub TSFE_Explore(rootDir,left,top,width,height,aspFileName)
	
	Dim fs,f, f1, fc, s
	Dim subFolders()
	dim halfwid
	dim exp
	dim tmp
	
	Set fs = CreateObject("Scripting.FileSystemObject")	
	halfwid=width/2
	
	'make sure path is of a right format
	rootDir=FormatPathSlashes(rootDir)
	
	'GET SUBMITTED VALUES:	
	if request.item("TSFEidOfClickedItem")="" then
		g_subm_req=0
	else
		g_subm_req=1
	end if

	if g_subm_req then
		g_subm_id=cint(request.item("TSFEidOfClickedItem"))
		g_arrSubm_expf= split(request.item("TSFEexpFolders"),",")
		g_subm_selItem= cint(request.item("TSFEselItem"))
	end if
	'GET SUBMITTED VALUES.
%>
	

	<form action="<%=aspFileName%>" METHOD="POST" name="TSFEform1">
	<input TYPE="hidden" name="TSFEidOfClickedItem">
	<input TYPE="hidden" name="TSFEexpFolders">
	<input TYPE="hidden" name="TSFEselItem">
	</form>
		
	
	<script language="JavaScript">	
	var imgFold='images/'
	
	//var image=imgFold+'fold.gif'
	var image=imgFold+'nclosed.gif'
	//var selImage=imgFold+'open.gif'
	var selImage=imgFold+'nopen.gif'
	var listImage=imgFold+'list.gif'
	var plusImage=imgFold+'plus.jpg'
	var minusImage=imgFold+'minus.jpg'	
	//var fullFoldImage=imgFold+'big_folder.gif'
	var fullFoldImage=imgFold+'folder2.jpg'
	//var fullFoldImage=imgFold+'fbang.bmp'

	var tmp
	var s=""
	var g_arrFileNames = new Array()	//file names array
	var g_iFileNamesCount				//number of names in g_arrFileNames array
	var g_selFoldPath					//selected folder path
	var g_iSelFileItem					//index of selected file item
	var g_arrFullFoldNames=new Array()	//array with full folder names
	var g_arrFullFoldNames_Count
	var g_strFileList= new Array()
	var g_strSelFoldPath=""
	var g_fileListLayer

	g_arrFullFoldNames_Count=0
	g_iSelFileItem=-1	
	

	//START SCROLLS CREATION (for Netscape only, Internet Explorer has layers scrolls already builtin )
	if(bw.ns)
	{
		onload = init
		function init() 
		{
			//reset dimension of scroll
			treeScroll.activate(5000,(tree.allItems.length+1)*20)
			filesScroll.activate()		

			initMouseEvents()
		}

		//scroll creates 4 parent layers:
		//theScrollName.ScrollWindow0.ScrollWindow0Screen.ScrollWindow0Content

		treeScroll = new Scroll(<%=left%>,<%=top+g_infoDivHei+g_helpDivHei%>,<%=halfwid%>-20,<%=height-g_infoDivHei-g_helpDivHei%>-20,0,"TSFETreeScroll")
		treeScroll.useH = true
		treeScroll.imgSet('images/nextstep/',20,19,45,0,1,0,1,1,1)
		treeScroll.drawBorder = true
		treeScroll.build()

		filesScroll = new Scroll(<%=left+halfwid%>,<%=top+g_helpDivHei+g_infoDivHei%>,<%=halfwid%>-20,<%=height-g_helpDivHei-g_infoDivHei%>-20,0,"TSFEFilesScroll")
		filesScroll .useH = true
		filesScroll .imgSet('images/nextstep/',20,19,45,0,1,0,1,1,1)
		filesScroll .drawBorder = true
		filesScroll .build()

		writeCSS (
			treeScroll.css +
			filesScroll.css 
			)
	}//NS

	//END SCROLLS CREATION

	
	if(bw.ie)
	{
		//HELP DIV:
		s='\n<div'
		s+='\nstyle="position:absolute;'
		s+='\nbackground:gray;'		
		s+='\ncolor:yellow;'
		s+='\nfont-family:arial;'
		s+='\nfont-size:15;'
		s+='\noverflow-y:hide;'
		s+='\noverflow-x:hide;'
		s+='\nwidth=<%=width%>;'
		s+='\nheight:<%=g_helpDivHei%>;'
		s+='\nleft:<%=left%>;'
		s+='\ntop:<%=top%>;"'
		s+='\n>'
		s+='\nFile Explorer - Click on text to see files or on icons to browse.'
		s+='\n</div>'

		document.writeln(s)
		//HELP DIV.				
		
		//INFO DIV:
		s='\n<div id=SelectedInfo'
		s+='\nstyle="position:absolute;'
		s+='\nbackground:lightyellow;'
		s+='\nfont-family:verdana;'
		s+='\nfont-size:15;'
		s+='\ncolor:darkblue;'
		s+='\noverflow-y:auto;'
		s+='\noverflow-x:hide;'
		s+='\nwidth=<%=width%>;'
		s+='\nheight:<%=g_infoDivHei%>;'
		s+='\nleft:<%=left%>;'
		s+='\ntop:<%=top+g_helpDivHei%>;"'
		s+='\n>'
		s+='\n</div>'

		document.writeln(s)
		//INFO DIV.				

		//FILE LIST DIV:		
		s='\n<div id="FileList" '
		s+='\nstyle="position:absolute;'
		s+='\noverflow-y:auto;'
		s+='\noverflow-x:auto;'
		s+='\nwidth=<%=halfwid%>;'
		s+='\nheight:<%=height-g_infoDivHei-g_helpDivHei%>;'
		s+='\nleft:<%=left+halfwid%>;'
		s+='\ntop:<%=top+g_infoDivHei+g_helpDivHei%>;"'
		s+='\n>'
		s+='\n</div>'
		
		document.writeln(s)
		//FILE LIST DIV.

		//TREE PARENT DIV:
		s='\n<div '
		s+='\nstyle="position:absolute;'
		s+='\noverflow-y:auto;'
		s+='\noverflow-x:auto;'
		s+='\nwidth=<%=halfwid%>;'
		s+='\nheight:<%=height-g_infoDivHei-g_helpDivHei%>;'
		s+='\nleft:<%=left%>;'
		s+='\ntop:<%=top+g_infoDivHei+g_helpDivHei%>;"'
		s+='\n>'

		document.writeln(s)
		//TREE PARENT DIV.
	}//IE
	
	else if(bw.ns)
	{
		//HELP LAYER:
		s='\n<layer'
		s+='\nposition="absolute";'
		s+='\nbgColor="gray";'
		s+='\nfgColor="yellow";'
		//s+='\nfont-family=arial;'
		//s+='\nfont-size=15;'
		//s+='\noverflow-y=hide;'
		//s+='\noverflow-x=hide;'
		s+='\nwidth=<%=width%>;'
		s+='\nheight=<%=g_helpDivHei%>;'
		s+='\nleft=<%=left%>;'
		s+='\ntop=<%=top%>;'
		s+='\n>'
		s+='\nFile Explorer - Click on text to see files or on icon to browse.'
		s+='\n</layer>'

		document.writeln(s)
		//HELP LAYER.
		
		//INFO LAYER:
		s='\n<layer name="SelectedInfo"'
		s+='\n class="NSInfoLayer"'
		//s+='\nposition="absolute";'
		//s+='\nbgColor="lightyellow";'
		//s+='\nfont-family="courier";'
		//s+='\nfontSize=10;'
		//s+='\ncolor="darkblue";'
		//s+='\noverflow-y=auto;'
		//s+='\noverflow-x=hide;'
		s+='\noverflow=hide;'
		s+='\nwidth=<%=width%>;'
		s+='\nheight=<%=g_infoDivHei%>;'
		s+='\nleft=<%=left%>;'
		s+='\ntop=<%=top+g_helpDivHei%>;'
		s+='\nCLIP: rect(<%=left%> <%=top+g_helpDivHei%> <%=width%> <%=g_infoDivHei%>);'
		s+='\n>'
		s+='\n</layer>'

		document.writeln(s)
		//INFO LAYER.
		
		//FILE LIST SCROLL:
		document.writeln('\n'+filesScroll.divStart)
		document.writeln('\n'+filesScroll.divEnd)
		num=1				
		g_fileListLayer=document.layers["TSFEFilesScroll"].document.layers["ScrollWindow"+num].document.layers["ScrollWindow"+num+"Screen"].document.layers["ScrollWindow"+num+"Content"]
		//FILE LIST SCROLL.
		
		//start of tree scroll
		document.writeln(treeScroll.divStart)

	}//NS

	document.write('<font size="'+2+'" face="'+'Verdana'+'">')
	
	//make tree
	tree=new makeTreeObj('makeTreeObj',0,0,20,50,'black','white',false)	

	if(bw.ns)
	{
		//parent layers of tree are scroll layers in netscape
		num=0
		obj=document.layers["TSFETreeScroll"].document.layers["ScrollWindow"+num].document.layers["ScrollWindow"+num+"Screen"].document.layers["ScrollWindow"+num+"Content"]
		tree.setParentLayerObj(obj)

		//tree.setParentLayer("TSFETreeParent")
	}

	tree.setOnItemIMGClickProc("onItemIMGClickProc")
	tree.setOnItemClickProc("onItemClickProc")	
	

	
	<%
	Set f = g_fs.GetFolder(rootDir)

	'INSERT ROOT ITEM:
	if g_subm_req then
		exp=g_arrSubm_expf(g_treeitems_count)
	else
		exp=1
	end if

	if(NumSubFolders(rootDir)>0)then
	%>
		root=tree.insertItem(0,'<%=f.name%>',fullFoldImage,selImage,<%=exp%>,'<%=rootDir%>')
	<%else%>
		root=tree.insertItem(0,'<%=f.name%>',image,selImage,<%=exp%>,'<%=rootDir%>')	
	<%end if%>

	g_arrFullFoldNames[g_arrFullFoldNames_Count]='<%=rootDir%>'
	g_arrFullFoldNames_Count++

	<%
	'INSERT ROOT ITEM.

	if g_subm_req then
		if g_treeitems_count=g_subm_id then
			SetFileList(rootDir)
		end if
	end if

	g_treeitems_count=g_treeitems_count+1
	'redim preserve ExtVB_FullPath(ExtVB_Count)
	'ExtVB_FullPath(ExtVB_Count)=rootDir
	'ExtVB_Count=ExtVB_Count+1
	%>


	<%InsertAllSubFolders rootDir%>

	window.status="Displaying all tree items ........ "
	treeHei=tree.displayItems()
	window.status="Displaying all tree items ........ Done"
	window.status=""
	
	<%
	if (g_subm_req) then
		if (g_subm_selItem>=0) then
		%>
			tree.setSelItem(<%=g_subm_selItem%>)
		<%
		end if
	end if
	%>

	document.writeln('</font>')	

	if(bw.ns)
	{
		onLoadInterval=setInterval('onLoadIntervalF()',100)
	}
	
	
	if(bw.ns)
	{
		//end of tree scroll
		document.writeln(treeScroll.divEnd)
	}
	else if(bw.ie)
	{	
		//end of tree's parent layer
		document.write("\n</div>")
	}

	</script>	

<%
end sub
%>