--Created: 5. junij 2000 16:29, ponedeljek
--Author: Tone koda  e-mail: tone.skoda@siol.net
--purpose: math functions

include C_struct.e --abs() ...(?)


--if positive or negative
--returns 1 or -1
global function NumberSign(atom num)
	if num<0 then return -1
	else return 1 end if
end function

--/topic Utilities
--/func abs( a )
--/desc Absolute value.
--/ret Absolute value of the atom.

--global function abs( atom a )
--    if a < 0 then
--        return -a
--    else
--        return a
--    end if
--end function


--rounds number
global function round(atom a)
	atom fl

	fl=floor(a)
	if abs(a-fl)<0.5 then return fl
	else return floor(a+NumberSign(a))
	end if
end function

global function IsPointInRect(atom x,atom y,
	atom x1,atom y1,atom x2,atom y2)
	
	if x<=x1 or x>= x2 or y<=y1 or y>=y2 then return false
	else return true end if
end function

global function IsPointInRectS(sequence point,
	sequence rect)
	
	if point[1]<=rect[1] or point[1]>=rect[3] 
		or point[2]<=rect[2] or point[2]>=rect[4] then return false
	else return true end if
end function

--includes borders, if point lies on borders of rect or in returns true
global function IsPointInRectIncS(sequence point,
	sequence rect)
	
	if point[1]<rect[1] or point[1]>rect[3] 
		or point[2]<rect[2] or point[2]>rect[4] then return false
	else return true end if
end function



global function Max(atom a, atom b)
    if a > b then
        return a
    else
        return b
    end if
end function


global function Min(atom a, atom b)
    if a < b then
        return a
    else
        return b
    end if
end function

--returns max number
global function max(sequence s)
	atom len
	atom maxiest

	len=length(s)

	if len=0 then
		printf(1,"\n%s",{"Error in max: s has no members"})
		return 0
	end if
	maxiest=s[1]	

	for i=1 to length(s) do
		if s[i]>maxiest then
			maxiest=s[i]
		end if
	end for

	return maxiest
end function

--returns min number
global function min(sequence s)
	atom len
	atom miniest

	len=length(s)

	if len=0 then
		printf(1,"\n%s",{"Error in min: s has no members"})
		return 0
	end if
	miniest=s[1]	

	for i=1 to length(s) do
		if s[i]<miniest then
			miniest=s[i]
		end if
	end for

	return miniest
end function


--sizes rc so that it's for percent smaller
--arg. percent : if 1 then returned same, if
--  0.5 then twice smaller etc
--arg. rc: has coordinates : left, top, right, bottom
--returns rectangle, zou have to round it with round()
--if zou want to use it as integer, cause they are floating
---------------------------------------------------------------------------
global function TS_ZoomRect(sequence rc,atom percent)
    atom centerx,centery,wid,hei

    
	wid=rc[3]-rc[1]
    hei=rc[4]-rc[2]
	
    centerx=rc[1]+(wid/2)
	centery=rc[2]+(hei/2)

	wid*=percent
	hei*=percent
	rc[1]=centerx-(wid/2)
	rc[2]=centery-(hei/2)
    rc[3]=centerx+(wid/2)
    rc[4]=centery+(hei/2)

--	rc[1]=round(rc[1])
--  rc[2]=round(rc[2])
--  rc[3]=round(rc[3])
--  rc[4]=round(rc[4])

    return rc
end function